﻿<System.Serializable()> Public NotInheritable Class Ranking
    Public Shared ReadOnly rankingFile As String = Application.StartupPath & "\ranking.dat"

    Private Sub New()
    End Sub

    Public Shared Function GetDefaultRanking(ByVal user As String) As List(Of Result)
        Dim def = New Result With {.Score = 0, .User = user, .Prolong = False}
        Return New List(Of Result)(New Result() {def, def, def, def, def, def, def, def, def, def})
    End Function

    Public Shared ReadOnly Property Instance() As Ranking
        Get
            Static _instance As Ranking
            If _instance Is Nothing Then
                Try
                    Dim inFile As New FileStream(rankingFile, FileMode.Open, FileAccess.Read)
                    Dim bf As New BinaryFormatter
                    _instance = bf.Deserialize(inFile)
                    inFile.Close()
                Catch ex As Exception
                    _instance = New Ranking
                    _instance.PublicRanking = GetDefaultRanking("だれかさん")
                    _instance.UsersRanking = New Dictionary(Of String, List(Of Result))
                End Try
            End If
            Return _instance
        End Get
    End Property

    Public PublicRanking As List(Of Result)
    Public UsersRanking As Dictionary(Of String, List(Of Result))

    Public Shared Sub Save()
        Dim outFile As New FileStream(rankingFile, FileMode.Create, FileAccess.Write)
        Dim bf As New BinaryFormatter
        bf.Serialize(outFile, Instance)
        outFile.Close()
    End Sub
End Class

<System.Serializable()> Public Structure Result
    Implements IComparable(Of Result)

    Public Score As UInteger
    Public User As String
    Public Prolong As Boolean

    Public Function CompareTo(ByVal other As Result) As Integer Implements System.IComparable(Of Result).CompareTo
        Return -Score.CompareTo(other.Score)
    End Function
End Structure
